/* PARALLEL */

#include "express.h" 

#define IMAX 258  /* +2 for buffers */
#define JMAX 258  /* +2 for buffers */
#define MAXCLUSTERS (IMAX * JMAX)

#define TCONV 6.73828       /* Convert NCUBE clock cycles to milliseconds */
#define SIZE_OF_SHORT 16    /* Number of bits in a short */
#define SHORTMASK 65535     /* Mask off all the bits in a short */
#define SIZE_OF_BYTE 8      /* Number of bits in a byte */
#define BYTEMASK 255        /* Mask off all the bits in a byte */

#define TRUE 1
#define FALSE 0

/* Message types */
#define EDGE 10
#define LIST 20
#define COMB 30
#define GLOB 40
#define RAND 41
#define DATA 50

#define MAXQ 20
#define DIMENSION 2
#define BOND_ORDER 4
#define LEVELS 5   /* should be no greater than log(base 2) IMAX */
#define MAXDIFF 4  /* Maximum energy difference between newspin 
                      and oldspin in the Metropolis update */

extern short spin[IMAX][JMAX];
extern short ibond[IMAX][JMAX]; 
extern short jbond[IMAX][JMAX]; 
extern short X_cluster[MAXCLUSTERS];
extern short Y_cluster[MAXCLUSTERS];
extern int cluster[IMAX][JMAX];
extern int N[MAXCLUSTERS/2];
/*
extern int ns[MAXCLUSTERS];
extern int csize[MAXCLUSTERS];
*/

/* Express stuff */
extern struct nodenv nodedata;
extern int procdim[2],proccoord[2];
extern int globsize[2],localsiz[2],orig[2];
extern int nprocs,procnum;

/* Parallel stuff */
extern int shiftsize[4];
extern int globisiz,globjsiz,globsites;
extern int left,right,top,bottom;
extern int Nedges,offset;
extern int isiz_short,jsiz_short,isiz_int,jsiz_int,jmax_short,jmax_int;
extern int max_isiz_int,max_jsiz_int,two_isiz_int,two_jsiz_int;
extern int max_isiz,max_jsiz;
extern int minits;

extern long randx;
extern int first;
extern char avesname[128],datatype[128];
extern char backname[128],outname[128];

extern float beta, p;
extern double volume;
extern int Q, isiz,jsiz,ksiz,imax,jmax,kmax,sites;
extern int sets,sweeps,wsweeps,metsweeps,totswps;
extern int Nclusters,maxsize,maxlabel,cluster_size;
extern int ASCII, BINARY;
extern int powerof2[LEVELS];
extern double energy_table[MAXDIFF+1];
extern char fname[128],lastfname[128];

/* Analysis stuff */

#define M 2        /* number of different energy or mag measurements */
#define MAXNA 200  /* max distance of autocorr measurements */

extern double lastNEA[M][MAXNA],EA[M][MAXNA],EA2[M][MAXNA];     /* energy */
extern double lastNMA[M][MAXNA],MA[M][MAXNA],MA2[M][MAXNA];     /* mag */
extern double lastNM2A[M][MAXNA],M2A[M][MAXNA],M2A2[M][MAXNA];  /* magsq */
extern double errEA[M][MAXNA],errMA[M][MAXNA],errM2A[M][MAXNA];

extern float energy[M], spheat[M], mag[M], suss[M];
extern float errener[M], errspheat[M], errspin[M], errsuss[M];
extern float maxenergy[M], minenergy[M], maxspin[M], minspin[M];
extern double avenergy[M], avenersq[M], avbinenersq[M];
extern double avspheat[M], avspheatsq[M];
extern double avspin[M], avspinsq[M], avbinspinsq[M];
extern double avsuss[M], avsusssq[M];
extern double partenergy[M], partenersq[M], partspin[M], partspinsq[M];

extern float magsq[M], imsuss[M], spinmeansq[M];
extern float errmagsq[M], errimsuss[M];
extern double partmagsq[M], avmagsq[M], avbinmagsqsq[M];
extern double avimsuss[M], avimsusssq[M];

extern float Qspin[MAXQ];
extern float mass, tmp, fluct, autocorr, spinmax, binmeansq;
extern int NA, binsz, numbins, maxdir, num_accept;
extern int cntaccept, cntenergy, cntspin, cntcorr, oldcount;

